
#ifndef _CALENDAR_H_
#define _CALENDAR_H_

#define CUR_TIME_YEAR   (2010)
#define CUR_TIME_MONTH  (3)
#define CUR_TIME_DAY    (9)

#define CUR_TIME_HOUR   (15.0f)
#define CUR_TIME_MINUTE (0.0f)

class Calendar
{
  public:
  
    static float GetInputHour()
    {
      return CUR_TIME_HOUR + CUR_TIME_MINUTE / 60.0f;
    }
    
    static float GetInputMinute()
    {
      return CUR_TIME_HOUR * 60.0 + CUR_TIME_MINUTE;
    }
    
    static uint16_t GetInputYear()
    {
      return CUR_TIME_YEAR;
    }
    
    static uint8_t GetInputMonth()
    {
      return CUR_TIME_MONTH;
    }
    
    static uint8_t GetInputDay()
    {
      return CUR_TIME_DAY;
    }
    
    static uint8_t GetInputDate()
    {
      return GetInputDay();
    }
    
    static uint8_t GetCorrectedMonth()
    {
      uint8_t monthNo = GetInputMonth();
      return (monthNo > 2) ? monthNo - 3 : monthNo + 9;
    }
    
    static uint16_t GetCorrectedYear()
    {
      uint16_t yearNo = GetInputYear();
      uint16_t monthNo = GetInputMonth();
      return (monthNo > 2) ? yearNo : yearNo - 1;
    }
};

#endif
