//======================================================================================
/** \file VNH3SP30WithBitsHeader.h
 *    Header for motor driver.
 *
 *  Revisions:
 *    \li  01-26-10  added comments
 *
 *  License:
 *    This file released under the Lesser GNU Public License. The program is intended
 *    for educational use only, but its use is not restricted thereto. 
 */
//======================================================================================

/// This define prevents this .h file from being included more than once in a .cc file
#ifndef _VNH3SP30_motor1_H_
#define _VNH3SP30_motor1_H_


//-------------------------------------------------------------------------------------
/** 
 *  
 */

class VNH3SP30WithBitsHeader
{
	protected:
		/**
		 * Stored prescaler value.
		 */
		uint16_t prescaler1;
		
		/**
		 * Stored mode.
		 */
		uint8_t mode1;
		
		/**
		 * Stored motor channel.
		 */
		uint8_t channel1;
		
		/**
		 * Stored direction.
		 */
		bool isClockwise1;
		
		/**
		 * Stored duty cycle percentage.
		 */
		uint8_t dutycycle_percent1;


	public:
		
		VNH3SP30WithBitsHeader();
		
		void set_channel(uint8_t channeltype);

		uint8_t get_channel();
		
		void set_mode(uint8_t wgm);

		uint8_t get_mode();
		
		void set_dutycycle(int8_t dutycycle);
		
		int8_t get_dutycycle();
		
		uint16_t compute_dutycycle(uint8_t percent);
		
		uint8_t compute_prescaler(uint16_t prescale_value);
		
		void set_direction(bool isClockwise);
		
		bool get_direction();
		
		void set_brake(bool brake);
		
		void set_prescaler(uint16_t prescale_value1);
		
		uint16_t get_prescaler();
 };

#endif // _VNH3SP30_motor1_H_
