
#include <stdlib.h>
#include <avr/io.h>
#include "base_text_serial.h"
#include "rs232int.h"

static rs232* theSP;

//coordinates for the lab
float mLat = 35.3039605;
float mLong = -120.6635398;

void showMainMenu()
{
  *theSP << "Choose an option:\n\n";
  *theSP << "\t- t: set the time\n";
  *theSP << "\t- c: set the coordinates\n";
  *theSP << "\t- z: set the time zone\n";
  *theSP << "\t- p: print current settings\n";
  *theSP << "\t- s: compute solar calculations\n";
  *theSP << "\t- h: help\n";
  *theSP << "\t- q: quit screen\n";
}

uint8_t getAnOption()
{
  uint8_t ch = '\0';
  while (true)
  {
    if (theSP->check_for_char())
    {
      ch = theSP->getchar();
      switch (ch)
      {
	case 't': case 'T':
	  return 't';
	case 'c': case 'C':
	  return 'c';
	case 'z': case 'Z':
	  return 'z';
	case 'p': case 'P':
	  return 'p';
	case 's': case 'S':
	  return 's';
	case 'h': case 'H':
	  return 'h';
	case 'q': case 'Q':
	  return 'q';
	default: break;
      }
    }
  }
  return ch;
}

void printSettings()
{
  *theSP << "Latitude: " << mLat << "Longitude: " << mLong << "\n";
}

int main()
{
  theSP = new rs232(9600, 1);
  *theSP << "Menu testing\n";
  showMainMenu();
  while (true)
  {
    uint8_t option = getAnOption();
    if (option == 'p')
    {
      printSettings();
    }
    if (option == 'q')
    {
      continue;
    }
    if (option == 'h')
    {
      showMainMenu();
    }
  }
  return 0;
}

    
    
    
  