
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "queue.h"
#include "rs232int.h"
#include "MyDebug.h"
#include "ADCFor128.h"
#include "stl_accutimer.h"

int main(int argc, char** argv)
{
  setUpDebug();
  MY_DEBUG("Testing debugger:\n");
  
  setUpADC();
  MY_DEBUG("ADC has been configured!\n");
  
  //testing add channels to queue

  uint8_t testChannels[] = {2};
  uint8_t i;
  for (i = 0; i < 1; i++)
  {
    enqueueChannel(testChannels[i]);
  }
  MY_DEBUG("All channels added to queue!\n");
  
  //testing channel reading and processing
  while (true)
  {
    uint32_t i = 0;
    for (i = 0; i < 1000000; i++);
    ADCChannelResult chValue = readNextChannel();
    MY_DEBUG("Last channel read: ");
    MY_DEBUG(chValue.channel);
    MY_DEBUG(" with value: ");
    MY_DEBUG(chValue.value);
    MY_DEBUG("\n");
    FORCE_PRINT(chValue.value);
    FORCE_PRINT("\n");
    uint8_t nextChannel = chValue.channel;
    enqueueChannel(nextChannel);
    
    ClockData clkData;
    clkData.minutes = 60 * 17;
    clkData.qSecs = 75;
    clkData.ticks = 46561;
    printClockData(clkData);
    
  }
  
  return 0;
}
  
  
  
  
